#ifndef __ADDR_RANGE_H__
#define __ADDR_RANGE_H__

typedef struct addr_range_ addr_range;
typedef struct addr_range_raw_ addr_range_raw;

/* everything in network byte order */
struct addr_range_raw_ {
    unsigned long first;
    unsigned long last;
    unsigned int end_time;
};

struct addr_range_ {
    addr_range_raw r;

    /* Returns 1 if the address ranges overlap in address space.
       The end time is not used in the comparison. */
    unsigned int (*end_time)(addr_range *ar);
    int (* overlap)(addr_range *ar1, addr_range *ar2);
    addr_range_raw (* raw)(addr_range *ar);
    unsigned long (*first_addr)(addr_range *ar);
    unsigned long (*last_addr)(addr_range *ar);  

    void (* adjust)(addr_range *ar, int clock_skew);
  
    void (* delete)(addr_range *ar);
    void (* debug_print)(addr_range *ar);
};

/* first & last in network byte order, end_time in host byte order */

addr_range *addr_range_new(unsigned long first, unsigned long last,
			   unsigned int end_time);

addr_range *addr_range_new_from_raw(addr_range_raw *raw);

#endif
