#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include "allocation.h"

/*static int overlap_range(allocation *alloc, addr_range *ar1, addr_range *ar2);*/
static unsigned int end_time(allocation *alloc);
static unsigned long first_addr(allocation *alloc);
static unsigned long last_addr(allocation *alloc);  
/*------------------------------------------------------------------*/
static int overlap_range(allocation *alloc, allocation *check){

    return alloc->a_range->overlap(alloc->a_range, check->a_range);
}
/*------------------------------------------------------------------*/
static unsigned int end_time(allocation *alloc) {
    return alloc->a_range->end_time(alloc->a_range);
}
/*------------------------------------------------------------------*/
static unsigned long owner_addr(allocation *alloc){

    return alloc->owner;
  
}
/*------------------------------------------------------------------*/
static unsigned long first_addr(allocation *alloc){

    return alloc->a_range->first_addr(alloc->a_range);
  
}
/*------------------------------------------------------------------*/
static unsigned long last_addr(allocation *alloc){

    return alloc->a_range->last_addr(alloc->a_range);
}
/*------------------------------------------------------------------*/
static addr_range *range(allocation *a) {
    return a->a_range;
}
/*------------------------------------------------------------------*/
static void delete(allocation **a) {
    (*a)->a_range->delete((*a)->a_range);
    memset(*a, 0, sizeof(allocation));
    free(*a);
    *a = NULL;
}
/*------------------------------------------------------------------*/
static unsigned int start_time(allocation *a) {
    return a->s_time;
}
/*------------------------------------------------------------------*/
static int is_prealloc(allocation *a) {
    return a->flag == ALLOCATION_PREALLOC;
}
/*------------------------------------------------------------------*/
static void debug_print(allocation *a) {
    printf("Start time %s", ctime((time_t *)&a->s_time));
    a->a_range->debug_print(a->a_range);
  
}
/*------------------------------------------------------------------*/
allocation *allocation_new(enum allocation_flag flag, addr_range *ar, unsigned int s_time, unsigned long owner) {
  
    allocation *alloc;
    alloc = (allocation *)malloc(sizeof(allocation));

    alloc->flag = flag;
    alloc->a_range = ar;
    alloc->s_time = s_time;
    alloc->owner = owner;
  
    alloc->overlap = overlap_range;
    alloc->end_time = end_time;
    alloc->start_time = start_time;
    alloc->first_addr = first_addr;
    alloc->last_addr = last_addr;
    alloc->owner_addr = owner_addr;
    alloc->is_prealloc = is_prealloc;
    alloc->range = range;

    alloc->delete   = delete;
    alloc->debug_print = debug_print;
    return alloc;

}
