#include <stdlib.h>
#include <stdio.h>

#include "list.h"
#include "addr_range.h"
#include "allocation.h"
#include "arec.h"

#include "cfg.h"
#include "cfgparser.h"

extern FILE *yyin;
extern int yyparse();

/* This is the list in which the Bison parser stores its output */
extern list *cfgparser_list;

list *cfg_parse(char *fname) {
    FILE *f = fopen(fname, "r");
    yyin = f;
    if(yyparse() == 1) {
        fprintf(stderr, "Unrecoverable error in configuration file %s\n", fname);
        exit(1);
    }
    return cfgparser_list;
}

void delete(cfg *c) {
    free(c->name);
    c->scope->delete(c->scope);
    free(c->arec.cache_fname);
    free(c->aap_addr);
    free(c);
}

cfg *cfg_new() {
    cfg *c = calloc(1, sizeof(cfg));
    c->STARTUP_WAIT = 150;
    c->ANNOUNCE_WAIT = 10;
    c->RESEND_WAIT = 1;
    c->REPEAT_INTERVAL = 30;
    c->ASA_INTERVAL = 30;
    c->ASRP_INTERVAL = 30;
  
    c->delete = delete;
    return c;
}
