#ifndef __CFG_H__
#define __CFG_H__

#include "list.h"
#include "addr_range.h"

typedef struct cfg_ cfg;

#define CFG_LARGE_SCOPE NULL

typedef enum {
  CFG_PC,
  CFG_MAAS
} cfg_type;

struct cfg_ {

  char *name;  /* the name of the configuration */

  cfg_type type;
  
  int STARTUP_WAIT;
  int ANNOUNCE_WAIT;
  int RESEND_WAIT;
  int REPEAT_INTERVAL;
  int ASA_INTERVAL;
  int ASRP_INTERVAL;
  char *aap_addr;
  int aap_port;

  addr_range *scope;
  
  struct {
    char *cache_fname;
  } arec;

  void (* delete)(cfg *c);
};

list *cfg_parse(char *filename);

cfg *cfg_new();
#endif
