#ifndef __MADCAP_ADDR_RANGE_H__
#define __MADCAP_ADDR_RANGE_H__

#include <string.h>

typedef struct madcap_addr_range_ madcap_addr_range;
typedef struct madcap_addr_range_raw_ madcap_addr_range_raw;

/* everything in network byte order */
struct madcap_addr_range_raw_ {
  unsigned long first;
  unsigned long last;
  unsigned int end_time;
};

struct madcap_addr_range_ {
 madcap_addr_range_raw r;

  /* Returns 1 if the address ranges overlap in address space.
     The end time is not used in the comparison. */
  unsigned int (*end_time)(madcap_addr_range *ar);
  int (* overlap)(madcap_addr_range *ar1, madcap_addr_range *ar2);
  madcap_addr_range_raw (* raw)(madcap_addr_range *ar);
  unsigned long (*first_addr)(madcap_addr_range *ar);
  unsigned long (*last_addr)(madcap_addr_range *ar);  

  void (* adjust)(madcap_addr_range *ar, int clock_skew);
  
  void (* delete)(madcap_addr_range *ar);
  void (* debug_print)(madcap_addr_range *ar);
};

/* first & last in network byte order, end_time in host byte order */

madcap_addr_range *madcap_addr_range_new(unsigned long first,
                                         unsigned long last,
                                         unsigned int end_time);

madcap_addr_range *madcap_addr_range_new_from_raw(madcap_addr_range_raw *raw);

#endif
